/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <curl/curl.h>
#include <iostream>
#include <string>
#include <thread>
#include <chrono>
#include "HTMLretrieve.h"
#include "sq.h"
using namespace std;
size_t write_to_string(void *ptr, size_t size, size_t nmemb, string stream)
{
	size_t realsize = size * nmemb;
	string temp(static_cast<const char*>(ptr), realsize);
	stream.append(temp);
	return realsize;
}
/* 
 *	Retrieve file through libcurl
 * 	Uses an url
 */	
int sq::retrieve_html(const char * url){
	int aux=0;
	this_thread::sleep_for (chrono::seconds(this->delay));
	CURL *curl;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_URL, url);
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 2L);
		curl_easy_setopt(curl, CURLOPT_TIMEOUT, 10L);
		curl_easy_setopt(curl, CURLOPT_USE_SSL, CURLUSESSL_TRY );
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_to_string);
		string response;
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);
		curl_easy_perform(curl);
		curl_easy_cleanup(curl);
		string url_str(url);
		if(response.length() > 0){
			this->parse(response,url_str);
			aux=1;
		}else{
			if(this->verbose==1)
				save_log("Failed file retrieve "+ string(url));
		}
	}
	return aux;
}
