/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <curl/curl.h>
#include <iostream>
#include <string>
#include <thread>
#include "HTMLretrieve.h"
#include "sq.h"
#include "uri.h"
#include "sql.h"
using namespace std;
void sq::double_points(string& link, string url_base){
	size_t slash_t = link.find('/');
	size_t colon_t = link.find(':');
	if(colon_t != string::npos && slash_t != string::npos){
		this->comparing(link);
	}else{
		try{
			uri base(url_base);
			//cout << "Conversion "<<<base.scheme()<<base.authority()<<base.path()<<endl;
			string result_link=base.input(link);
			if(result_link.size()>0)
				this->comparing(result_link);
		}catch(uri::Invalid i){
			save_log(i.reason());
		}
		
	}
}

void sq::delete_html(string& link){
	size_t location = link.find_last_of('/');
	++location;
	link=link.substr(0,location);
	//if(this->verbose==1)
		//cout << url <<endl;
}
string sq::obtain_domain(string& link){
	string domain(url);
	size_t slash=domain.find("//");
	slash+=2;
	slash=domain.find("/",slash);
	domain=domain.substr(0,slash);
	//if(this->verbose==1)
		//cout << this->domain <<endl;
	return domain;
}
string sq::previous_folder(string& link){
	string alternative(url);
	size_t size=alternative.size();
	--size;
	if(alternative[size]=='/'){
		size_t slash=alternative.rfind("/",--size);
		alternative=alternative.substr(0,++slash);
		
		//if(this->verbose==1)
			//cout << this->alternative << endl;
	}
	return alternative;
}
void sq::comparing(string& link){

	size_t slash=link.find("//");
	slash+=2;
	size_t slash2=link.find("/",slash);
	string domain=link.substr(0,slash2);
	domain=domain.substr(slash);
	size_t point=domain.rfind(".");

	domain=domain.substr(0,point);
	size_t point_2=domain.rfind(".");
	//cout << domain << endl;
	if(point_2!=string::npos){
		domain=domain.substr(++point_2);
		//if(this->verbose==1)
		//	cout << domain << endl;
	}
	auto et=this->banned.find(domain);
	if(et==this->banned.end()){
		this->insert_link(link);

	}
}
void sq::insert_link(string& link){
	bool islock=false;
	if(lock==0){
		islock=true;
		size_t lo=link.find(this->locked);
		if(lo!=string::npos)
			islock=false;
	}
	if(!islock){
		int control=sqlite_insert(link.c_str(),link_text.c_str(),this->name.c_str());
		if(this->verbose==1){
			if(control==1){
				cout << "Link inserted: "<<link<< endl;
			}else if(control==0){
				save_log("Failed link insertion: "+link);
			}
		}
	}
	this->link_text="";
}
