/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include "sq.h"
using namespace std;

/*
 * Load program configuration from seer.conf
 * 
 */
void sq::load_config(){
	ifstream queue_saved("seer.conf");
	string line;
	int i=0;
	while(getline(queue_saved,line)){
		size_t points=line.find(":");
		std::string option=line.substr(0,points);
		size_t nm=option.find("name");
		if(nm!= std::string::npos){
			line=line.substr(++points);
			this->name= line;
		}
		size_t v=option.find("verbose");
		if(v!= std::string::npos){
			line=line.substr(++points);
			this->verbose= stoi(line);
		}
		size_t da=option.find("daemon");
		if(da!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->min_url_size= stoi(line);
		}
		i++;

	}
	queue_saved.close();
	if(i<2){
		this->name="sq1";
		this->verbose=1;
		this->daemon=0;
		save_conf();

	}

}
void sq::save_conf(){
	ofstream config("seer.conf");
	config <<"name:"<< this->name << endl;
	config <<"verbose:"<< this->verbose << endl;
	config <<"daemon:"<< this->daemon << endl;
	config.close();
}
void sq::save_log(string text){
	ofstream out(this->log,ofstream::app);
	out << text << endl;
	out.close();
}
