/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <string>
#include <thread>
#include "sq.h"
#include "sql.h"
#include "HTMLretrieve.h"
using namespace std;

void sq::thread_crawl(){
	thread (&sq::crawl_bucle, this).detach();
}
/*
 * Crawler loop
 *
 */
void sq::crawl_bucle(){

	int fails=0;
	while(this->isCrawling && sqlite_rowid(this->name)>= this->position && fails <= this->max_fails){

		string line;
		int rc=sqlite_select(this->position, this->name, this->url);
		if(rc){
			if(this->position%100==0){
				save_sq();
			}
			if(this->verbose==1){
				cout <<"----------------"<< endl;
				cout << "Link: "<< this->url << endl;
			}
			string robot=this->url;
			size_t point=robot.find(".");
			point=robot.find("/",point);
			if(point!=string::npos){
				robot=robot.substr(0,point+1);
				robot+="robots.txt";
		
				this->double_points(robot,this->url);
			}	

			int fail=this->retrieve_html(this->url.c_str());
			if(max_fails!=0){
				if(fail==0)
					++fails;
				else
					fails=0;
			}
		}else{
			save_log("Failed link selection");
		}
		++this->position;
	}
	if(this->verbose==1){
		save_log("Crawling stopped");
		save_log(to_string(sqlite_rowid(this->name)) +" "+ to_string(this->position));
	}
}
