#include "datalite.h"
#include <sqlite3.h>
#include <iostream>
#include <fstream>
using namespace std;
static int callback(void *NotUsed, int argc, char **argv, char **azColName){ return 0; }
int datalite::create(){	
	sqlite3 * sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	int result = 0;

	if (!rc){
		char *zErrMsg = 0;
		string sql = "DROP TABLE IF EXISTS COB; \
			CREATE TABLE COB(    \
			LINK TEXT NOT NULL UNIQUE, \
			TITLE TEXT, \
			METAINFO TEXT \
			);";
		rc = sqlite3_exec(sq, sql.c_str(), callback, 0, &zErrMsg);
		if (rc == SQLITE_OK)
			result = SQLITE_OK;
		else{
			sqlite3_free(zErrMsg);
			result = rc;
		}
	} else
		result = 1;
	
	sqlite3_close(sq);
	return result;
}
datalite::datalite(const string& file): _file(file){
	_position = 1;
	_last_position = 1;
	int result = create();
	if(result != 0)
	  throw datalite::Invalid("Couldn't create database.\n ERROR CODE: " + to_string(result));
}
/*
 * Return:
 * 0 : failed
 * 1 : OK
 * 2 : inserted before
 */
int datalite::insert_row(const string& link, const string& title, const string& metainfo){
	sqlite3 * sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	int result = 0;

	if (!rc){
		sqlite3_stmt * res;
		string sql = "INSERT INTO COB VALUES ('";
		sql += link + "', '" + title + "', '"+ metainfo +"');";
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
		if (rc == SQLITE_OK) {
			int step = sqlite3_step(res);
			if(step == SQLITE_CONSTRAINT)
				result = 2;
			else if(step == SQLITE_DONE)
				result = 1;
			else if(step == SQLITE_OK)
				result = 1;
		}else
			result = 2;
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}

int datalite::delete_row(const string& data){

	sqlite3 * sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	int result = 0;

	if (!rc){
		sqlite3_stmt * res;
		string sql = "DELETE FROM COB WHERE link=" + data +";";
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
		if (rc == SQLITE_OK) {
			int step = sqlite3_step(res);
			if(step == SQLITE_CONSTRAINT)
				result = 2;
			else if(step == SQLITE_DONE)
				result = 1;
			else if(step == SQLITE_OK)
				result = 1;
		}else
			result = 2;
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}

int datalite::update_title(const string& title){

	sqlite3 *sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	int result = 0;

	if (!rc){
		
	  	sqlite3_stmt *res;
		string sql = "UPDATE COB SET TITLE = TITLE || ' ' || '" + title + "' "
			"where rowid=" + to_string(_position - 1);
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
		
		if(rc == SQLITE_OK){
			sqlite3_step(res);
			result = SQLITE_OK;
		} else result = rc;
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}

int datalite::search(const string& pattern){
	_found_links = set<string>();
	string word;
	size_t space = pattern.find(' ');
	int result = 0;
	if(space == string::npos){
		result = get_like_link_title_and_metainfo(pattern);
		if(result == 1){
			result = get_like_link_and_title(pattern);
			if(result == 1){
				result = get_like_title_and_metainfo(pattern);
				if(result == 1){
					result = get_like_link_title_or_metainfo(pattern);
				}
			}
		}
	} else {
		result = 1;
		while(space != string::npos && result != 2){
			size_t next_space = pattern.find(' ', space + 1);
			if(next_space != string::npos)
				word = pattern.substr(space + 1, next_space - space - 1);
			else
				word = pattern.substr(space + 1);

			result = get_like_link_title_and_metainfo(word);
			if(result == 1){
				result = get_like_link_and_title(word);
				if(result == 1){
					result = get_like_title_and_metainfo(word);
					if(result == 1){
						result = get_like_link_title_or_metainfo(word);
					}
				}
			}
			space = next_space;
		}
	}
	_found_links = set<string>();
	return result;
}

/*
 * Error: line.size = 0
 * Success: line.size > 0
 *
 */
string datalite::get_new_line(){

	sqlite3 *sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	string link;
	if (!rc){
		
		sqlite3_stmt *res;
		string sql = "SELECT LINK FROM COB WHERE rowid=" + to_string(_position);
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);

		if (rc == SQLITE_OK) {
			sqlite3_step(res);

			const char * retri = (char *) sqlite3_column_text(res,0);
			if(retri != NULL){
				
				link = string(retri);

				++_position;
			}
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return link;
}
/*
 * Error: line.size = 0
 * Success: line.size > 0
 *
 */
string datalite::get_link(int64_t position){
	sqlite3 *sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	string link;

	if (!rc){
		
		sqlite3_stmt *res;
		string sql="SELECT LINK FROM COB WHERE rowid=" + to_string(position);
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);

		if (rc == SQLITE_OK) {
			sqlite3_step(res);
			const char * retri=(char *) sqlite3_column_text(res,0);
			if(retri != NULL)
				link=string(retri);

			
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return link;
}

bool datalite::is_valid_line(){
	bool valid = false;
	if(_position <= _last_position) valid = true;
	else {
		_last_position = get_last_position();
 		if(_position <= _last_position) valid = true;
		else valid = false;
	}
	return valid;
}	

/*
 * Return rowid if worked and -1 if doesn't
 *
 */
int64_t datalite::get_last_position(){
	if(_position > _last_position){
		sqlite3 *sq;
		int rc = sqlite3_open(_file.c_str(), &sq);

		if (!rc){
			sqlite3_stmt *res;
			string sql = "SELECT rowid FROM COB WHERE rowid=(SELECT MAX(rowid) FROM COB)";
			rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);

			if (rc == SQLITE_OK) {
				sqlite3_step(res);

				const char *retri=(char *) sqlite3_column_text(res,0);
				if(retri != NULL){
					string text(retri);
					_last_position = stoll(text);

				}
			}
			sqlite3_finalize(res);
		}
		sqlite3_close(sq);
	}
	return _last_position;
}

void datalite::set_position(int64_t position){
	if(position <= _last_position) _position = position;
	else {
		_last_position = get_last_position();
 		if(position <= _last_position) _position = position;
		else throw datalite::Invalid("Rowid greater than table rowid");

	}
}
void datalite::export_dl(const string& file){
	ofstream save(file);
	save << "file:" << _file << endl;
	save << "position:" << to_string(_position) << endl;
	save.close();
}
void datalite::import_dl(const string& file){
	ifstream queue_saved(file);
	std::string line;
	while(getline(queue_saved,line)){
		size_t points=line.find(":");
		string option=line.substr(0,points);
		size_t nm=option.find("file");
		if(nm!= std::string::npos){
			line=line.substr(++points);
			this->_file= line;
		}
		size_t max=option.find("position");
		if(max!= std::string::npos){
			line=line.substr(++points);
			this->_position= stoll(line);
		}

	}
	queue_saved.close();
}
datalite& datalite::operator=(datalite& src){

	if (this != &src) { 
		_file = src.get_file();
		_position = src.get_position();
		_last_position = src.get_last_position();
	}
	return *this;
}
int datalite::update_metainfo(const string& metainfo){
	sqlite3 *sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	int result = 0;
	if (!rc){
		sqlite3_stmt *res;
		string sql = "UPDATE COB SET METAINFO = '" + metainfo + "' "
		  "where rowid=" + to_string(_position - 1);
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
		if(rc == SQLITE_OK){
			sqlite3_step(res);
			result = SQLITE_OK;
		} else result = rc;
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}
string datalite::get_title(const int64_t& position){
	sqlite3 *sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	string link;
	if (!rc){
		sqlite3_stmt *res;
		string sql = "SELECT TITLE FROM COB WHERE rowid=" + to_string(position);
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
		if (rc == SQLITE_OK) {
		
			sqlite3_step(res);
			const char * retri=(char *) sqlite3_column_text(res,0);
		if(retri != NULL)
			link=string(retri);
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return link;
}
string datalite::get_metainfo(const int64_t& position){
	sqlite3 *sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	string link;
	if (!rc){
		sqlite3_stmt *res;
		string sql = "SELECT METAINFO FROM COB WHERE rowid=" + to_string(position);
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
		if (rc == SQLITE_OK) {
		
			sqlite3_step(res);
			const char * retri=(char *) sqlite3_column_text(res,0);
		if(retri != NULL)
			link=string(retri);
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return link;
}

int datalite::get_like_link_title_and_metainfo(const string& pattern){
	string sql = "SELECT LINK FROM COB WHERE LINK LIKE '%" + pattern + "%' AND"
		" TITLE LIKE '%" + pattern + "%' AND METAINFO LIKE "
		"'%" + pattern + "%';";
	return show_unique_database_fields(sql);
	
}
int datalite::get_like_title_and_metainfo(const string& pattern){
    string sql = "SELECT LINK FROM COB WHERE TITLE LIKE '%" + pattern + "%' AND"
		" METAINFO LIKE '%" + pattern + "%';";
	return show_unique_database_fields(sql);
}
int datalite::get_like_link_and_title(const string& pattern){
	string sql = "SELECT LINK FROM COB WHERE LINK LIKE '%" + pattern + "%' AND"
		" TITLE LIKE '%" + pattern + "%';";
	return show_unique_database_fields(sql);
}
int datalite::get_like_link_title_or_metainfo(const string& pattern){
	string sql = "SELECT LINK FROM COB WHERE LINK LIKE '%" + pattern + "%' OR"
		" TITLE LIKE '%" + pattern + "%' OR METAINFO LIKE '%" + pattern + "%';";
	return show_unique_database_fields(sql);
}
void datalite::insert_datalite(datalite& db){
	int64_t position = db.get_position();
	db.set_position(1);
	cout << "Wait until insertion stop" << endl;
	while(db.is_valid_line()){
		string title = db.get_title(db.get_position());
		string metainfo = db.get_metainfo(db.get_position());
		insert_row(db.get_new_line(), title, metainfo);
	}
	cout << "Insertion finished" << endl;
	db.set_position(position);
}
/*
 * Return:
 * 0 : failed
 * 1 : OK
 * 2 : cancelled by user
 */
int datalite::show_unique_database_fields(const string& sql){
	sqlite3 *sq;
	int rc = sqlite3_open(_file.c_str(), &sq);
	int result = 0;

	if (!rc){
		sqlite3_stmt *res;
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);

		if (rc == SQLITE_OK) {

			int step = sqlite3_step(res);
			int option;
			do{

				int i = 0;
				while (step == SQLITE_ROW && i < 10) {
					char * text_c = (char *) sqlite3_column_text(res, 0);
					string text(text_c);

					if(_found_links.find(text) == _found_links.end()){
						cout << text << endl;
						_found_links.insert(text);
					}
					step = sqlite3_step(res);
					++i;
				}
				if(i > 5){
					cout << "Do you want more links?\n"
						"1.- Yes\n"
						"2.- No" << endl;
					cin >> option;
				} else
					option = 1;
				
			}while(option == 1 && step == SQLITE_ROW);
			result = option;
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}
