#ifndef __DATALITE__
#define __DATALITE__
#include <string>
#include <set>
using namespace std;
class datalite {

	string _file;
	int64_t _position;
	int64_t _last_position;
	int create();
	set<string> _found_links;
	public:
		datalite(): _file("database.sqlite"), _position(1), _last_position(1){}
		datalite(const string& file);

		int insert_row(const string& link, const string& title = "", const string& metainfo = "");
		int delete_row(const string& data);
		int update_title(const string& title);
		int search(const string& pattern);
		int get_like_link_title_and_metainfo(const string& pattern);
		int get_like_title_and_metainfo(const string& pattern);
		int get_like_link_and_title(const string& pattern);
		int get_like_link_title_or_metainfo(const string& pattern);
		int show_unique_database_fields(const string& sql);
		int update_metainfo(const string& metainfo);
		string get_metainfo(const int64_t& position);
		string get_title(const int64_t& position);
		string get_file(){ return _file; }
		void set_file(const string& file){ _file = file; }
		void insert_datalite(datalite& db);
		string get_new_line();
		string get_link(int64_t position);
		bool is_valid_line();
		
		int64_t get_position(){ return _position; }
		int64_t get_last_position();
		void set_position(int64_t position);
		
		void export_dl(const string& file = "database.conf");
		void import_dl(const string& file = "database.conf");
		datalite& operator=(datalite& src);
		struct Invalid{
			Invalid(const string& reason):reason_(reason){}
			string reason()const{return reason_;}
			private:
				string reason_;
		};
};
#endif
