/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <curl/curl.h>
#include <iostream>
#include <string>
#include <fstream>
#include "spidey.h"
#include "page.h"
#include "uri.h"
#include "datalite.h"
using namespace std;
void clean_stdin(){
    int c;
    do{
        c = getchar();
    } while (c != '\n' && c != EOF);
}
void show_help(){
	cout << "Help menu" << endl;
	cout << "se -a URL -- Daemon mode" << endl;
	cout << "se -l -- Load last sq" << endl;
	cout << "se URL -- User mode" << endl;
	cout << "se -h -- Help" << endl;
	cout << "Official page: https://autistici.org/alkeon/" << endl;
}

int main(int argc, char *argv[]){

	spidey seer;
	if(argc>1){
		string load(argv[1]);
		ifstream crawled_links("banned");
		string line;
		while(getline(crawled_links,line)){
			seer.ban_word(line);
		}
		crawled_links.close();
		if(load!="-l"){
			if(load=="-h" or load=="--help"){
				show_help();
			}else{
					
				if(load=="-a" && argc==3){
					ofstream t(seer.get_name() + ".log", ofstream::trunc);
					t << "";
					t.close();
					seer.set_daemon(true);
					seer.set_crawling_mode(true);
					string url(argv[2]);
					try{
						seer.save();
						seer.first_link(url);
						seer.crawl();
					}catch(page::Invalid e){
						seer.save_log("Failed page download " + url);
					}catch(uri::Invalid e){
						seer.save_log("Failed uri parsing" + url);
					}

				}else{
					if(argc==2){
						if(seer.is_loadable()) {
							cout << "Do you want to load previous Seer session" <<endl;
							int eleccion;
							cout << "0 .- No" <<endl;
							cout << "1 .- Yes" <<endl;
							cin >> eleccion;
							if(eleccion == 1){
								seer.load();
								if(!seer.get_daemon()){
									seer.thread_crawl();
								} else {
									seer.crawl();
								}
							} else {
								seer.set_daemon(false);
								seer.create_new();
								string url(argv[1]);
								try{
									seer.first_link(url);
									seer.thread_crawl();
								}catch(page::Invalid e){
									seer.save_log("Failed page download " + url);
								}catch(uri::Invalid e){
									seer.save_log("Failed uri parsing" + url);
								}
							}
						} else {
							seer.set_daemon(false);
							seer.create_new();
							string url(argv[1]);
							try{
								seer.first_link(url);
								seer.thread_crawl();
							}catch(page::Invalid e){
								seer.save_log("Failed page download " + url);
							}catch(uri::Invalid e){
								seer.save_log("Failed uri parsing" + url);
							}
						}
					}else
						seer.save_log("Wrong console parameters ");
				}
		
			}
		} else {

			seer.load();
			if(!seer.get_daemon()){
				seer.thread_crawl();
			}else{
				seer.crawl();
			}
		}
	
		if(seer.get_verbose() && !seer.get_daemon()){
			int i=0;
			while(i==0){
				int eleccion;
				cout << "1.- Start/Stop crawling"<<endl;
				cout << "2.- Search"<<endl;
				cout << "3.- Add link"<< endl;
				cout << "4.- Change sq"<< endl;
				cout << "5.- Import bookmarks"<< endl;
				cout << "6.- Add sq"<< endl;
				cout << "7.- Close"<< endl;
				cin >> eleccion;

				switch(eleccion){
					case 7:i=1;break;
					case 6:{
						seer.set_crawling_mode(false);
						string database;
						cout << "Write datalite file" << endl;
						cin >> database;
						datalite db;
						db.set_file(seer.get_name() + ".sqlite");
						db.import_dl(seer.get_name() + ".config");
						datalite aux;
						aux.set_file(database + ".sqlite");
						aux.import_dl(database + ".config");
						db.insert_datalite(aux);
						db.export_dl(seer.get_name() + ".config");
					};break;
					case 5:{
						seer.set_crawling_mode(false);
						string url;
						cout << "Write absolute path for file" << endl;
						cin >> url;
						datalite db(seer.get_name() + ".sqlite");
						db.insert_row(url);
						db.export_dl();
					};break;
					case 4:{
						seer.set_crawling_mode(false);
						string name;
						cout << "Write sq name" << endl;
						cin >> name;
						seer.set_name(name);
						
					};break;
					case 3:{
						seer.set_crawling_mode(false);
						string url;
						cin >> url;
						datalite db(seer.get_name() + ".sqlite");
						db.insert_row(url);
						db.export_dl();
					};break;
					case 2:{
						seer.set_crawling_mode(false);
						cout << "\n\n\n\n\t\t\tSeer\n\n\n\n\t\t";
						char char_input[100];
						clean_stdin();
						datalite db;
						db.set_file(seer.get_name() + ".sqlite");
						db.import_dl(seer.get_name() + ".config");
						cin.getline(char_input,100);
						string word(char_input);
						try{
							int rc = db.search(word);
							//cout << rc << endl;
							if(rc != 0)
								seer.save_log("Failed database search");
						}catch(datalite::Invalid e){
							cout << e.reason();
						}
					};break;
					case 1:{
						if(seer.get_crawling_mode()){
							seer.set_crawling_mode(false);
		
						}else{
							seer.set_crawling_mode(true);
							seer.thread_crawl();
						}
					};break;
				}
			}
		}
		
	}else
		show_help();
}
