/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <curl/curl.h>
#include <iostream>
#include <string>
#include <fstream>
#include "HTMLretrieve.h"
#include "sq.h"
#include "sql.h"
using namespace std;
void clean_stdin(){
    int c;
    do{
        c = getchar();
    } while (c != '\n' && c != EOF);
}

int main(int argc, char *argv[]){

	sq user;
	if(argc>1){
		user.load_config();
		ofstream t(user.log,ofstream::trunc);
		t << "";
		t.close();
		string load(argv[1]);
	
		ifstream crawled_links("banned");
		string line;
		while(getline(crawled_links,line)){
			user.banned.insert(line);
		}
		crawled_links.close();
	
		if(load!="-l"){
			if(load=="-h"){
				cout << "Ayuda para el uso de Seer" << endl;
				cout << "se -a URL -- Daemon mode"<< endl;
				cout << "se -l -- Load last sq" << endl;
				cout << "se URL -- User mode"<< endl;
				cout << "se -h -- Help"<< endl;
				cout << "Official page: https://autistici.org/alkeon/"<< endl;
			}else{
				if(load=="-a" && argc==3){
					user.daemon=1;
					user.create_sq();
					user.url.assign(argv[2]);
					int rc=sqlite_create(user.name);
					if(rc){
						rc=sqlite_insert(argv[2], " ",user.name);
						if(rc)
							user.crawl_bucle();
						else
							user.save_log("Failed link insertion "+user.url);
					}else{
						user.save_log("Failed database creation");
					}

						
				}else{
					if(argc==2){
						user.daemon=0;
						user.create_sq();
						user.url.assign(argv[1]);
						int rc=sqlite_create(user.name);

						if(rc){
							rc=sqlite_insert(argv[1], " ",user.name);
							if(rc)
								user.thread_crawl(); 
							else
								user.save_log("Failed link insertion "+user.url);

						}else{
							user.save_log("Failed database creation");
						}
					}else
						user.save_log("Wrong console parameters ");
				}
		
			}
		}

		if(load=="-l"){
			user.load_sq();
			if(user.daemon==0){
				user.thread_crawl();
			}else{
				user.crawl_bucle();
			}
		}
	
		if(user.verbose==1 && user.daemon==0){
			int i=0;
			while(i==0){
				int eleccion;
				cout << "1.- Start/Stop crawling"<<endl;
				cout << "2.- Search"<<endl;
				cout << "3.- Add link"<< endl;
				cout << "4.- Change sq"<< endl;
				cout << "5.- Import bookmarks"<< endl;
				cout << "6.- Close"<< endl;
				cin >> eleccion;

				switch(eleccion){
					case 6:i=1;break;
					case 5:user.import_bookmarks();break;
					case 4:user.change_sq();break;
					case 3:{
						user.isCrawling=0;
						string url;
						cin >> url;
						user.retrieve_html(url.c_str());
					};break;
					case 2:{
						cout << "\n\n\n\n\t\t\tSeer\n\n\n\n\t\t";
						char char_input[100];
						clean_stdin();
						cin.getline(char_input,100);
						string word(char_input);
						int rc=sqlite_se(user.name,word);
						if(!rc)
							user.save_log("Failed database search");
					};break;
					case 1:{
						if(user.isCrawling){
							user.isCrawling=0;
		
						}else{
							user.isCrawling=1;
							user.thread_crawl();
						}
					};break;
				}
			}
		}
	}else
		user.save_log("Wrong console parameters ");
}



