#ifndef __PAGE__
#define __PAGE__
#include <string>
#include <sstream>
#include <utility>
#include <string>
#include "delimiter.h"
using namespace std;

class page {

	istringstream _source_page;
	vector<delimiter> _delimiters_link;
	vector<delimiter> _delimiters_title;
	vector<delimiter> _delimiters_metainfo;
	string _line;
	string _title;
	string _keywords;
	string _description;
	string _first_paragraph;
	int _description_max_length, _title_max_length, _paragraph_max_length;
	string delete_whitespaces(string line);
	int _tag_controller;
	void find_description(const string& url, const delimiter& delimit);
	public:
		page(const string& url, int description_max_length = 170,
		int title_max_length = 170, int paragraph_max_length = 130);
		void set_delimiter(const delimiter& delimiter);
		void delete_delimiter(const delimiter& delimiter);

		void scrap_title();
		pair<string, string> scrap_url();
		void scrap_metainfo();
		pair<string, string> scrap_robots_info();

		void from_bookmark(const string& file);		
		pair<string,string> next_link();
		string get_title(){ return _title; }
		bool has_next_line(){ return !_source_page.eof(); }
		string get_metainfo();
		struct Invalid{
			Invalid(const string& reason):reason_(reason){}
			string reason()const{ return reason_; }
			private:
				string reason_;
		};
};
#endif
