/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <sstream>
#include "sq.h"
#include "sql.h"
using namespace std;

void sq::parse(string data,string url){
	istringstream doc(data);
	string line,link_text;
	while(getline(doc,line)){
		size_t ref=line.find("href=\"");
		if(ref!= string::npos){
			ref+=6;
			line=line.substr(ref);
			size_t first=line.find("\"");
			if(first!= string::npos ){
				link_text=line.substr(first);
				line=line.substr(0,first);
				ref=line.find(";");
				if(ref== string::npos){
					size_t hash=line.find("#");
					if(hash!=string::npos){
						line=line.substr(0,hash);
					}
					int size =line.size();
					if(size < this->max_url_size && size > this->min_url_size){
						cout << line << endl;
						size_t angular=link_text.find('>');
						if(angular!=string::npos){
							++angular;
							link_text=link_text.substr(angular);
							size_t end=link_text.find("</a>");
							if(end!=string::npos){
								link_text=link_text.substr(0,end);
								angular=link_text.find('>');
								size_t reverse_angular=link_text.find('<');
								if(angular==string::npos && reverse_angular==string::npos)
									this->link_text=link_text;
								else
									this->link_text="";
							}else{
								this->link_text="";
							}
						}else{
							this->link_text="";
						}
						this->double_points(line,url);
						this->link_text="";
					}
				}
			}
		}else{
			size_t second =line.find("<title>");
			if(second!= string::npos){
				second+=7;
				line=line.substr(second);
				//cout << line << endl;
				size_t tercero=line.find("</title>");
				if(tercero!= string::npos){
					line=line.substr(0,tercero);
			
					if(line.size() < 500 ){
						
						int rc=sqlite_up(this->name,this->position,line);
						if(!rc)
							save_log("Failed title update "+line);
					}
				}
			}else{
				size_t third=line.find("<loc>");
				if(third!= string::npos){
					third+=5;
					line=line.substr(third);
					size_t fourth=line.find("<");
					line=line.substr(0,fourth);
					this->double_points(line,url);
				}else{
					size_t ref=line.find("Sitemap: ");
					size_t ht=line.find("http");
					if(ref!= string::npos && ht != string::npos){
						ref+=9;
						line=line.substr(ref);
						this->double_points(line,url);
					}
				}
			}
		}
	}
	doc.str(string());
}
