#include <iostream>
#include <string>
#include <fstream>
#include <thread>
#include <unordered_set>
#include "spidey.h"
#include "page.h"
#include "uri.h"
#include "datalite.h"
#include "delimiter.h"
using namespace std;

void spidey::first_link(const string& link){
	uri first(link);
	datalite temp_db(_name + ".sqlite");
	temp_db.export_dl(_name + ".config");
	if(!is_banned(link) && !is_locked(link))
		temp_db.insert_row(link);
}
bool spidey::is_loadable(){
	ifstream queue_saved("seer.conf");
	bool is_loadable = false;
	if(queue_saved){
		string line;
		while(getline(queue_saved,line)){
			size_t points=line.find(":");
			string option=line.substr(0,points);
			size_t nm=option.find("name");
			if(nm!= std::string::npos){
				line=line.substr(++points);
				ifstream queue_saved2(line + ".config");
				if(queue_saved2) is_loadable = true;
			}
		}
	}
	return is_loadable;
}
void spidey::create_new(){ 
	int aux;
	cout << "Start crawling by default"<<endl;
	cout << "1.- Yes"<< endl;
	cout << "2.- No"<< endl;
	cin >> aux;
	if(aux==1){
		this->_is_crawling=1;
	}else{
		this->_is_crawling=0;
	}
	cout << "Verbose"<<endl;
	cout << "1.- Yes"<< endl;
	cout << "2.- No"<< endl;
	cin >> aux;
	if(aux==1){
		this->_verbose=1;
	}else{
		this->_verbose=0;
	}
	cout << "Daemon mode"<<endl;
	cout << "1.- Yes"<< endl;
	cout << "2.- No"<< endl;
	cin >> aux;
	if(aux==1){
		this->_is_daemon=1;
	}else{
		this->_is_daemon=0;
	}
	cout << "Skip useless domains"<<endl;
	cout << "1.- Yes"<< endl;
	cout << "2.- No"<< endl;
	cin >> aux;
	if(aux==1){
		this->_skip_useless_domains=1;
	}else{
		this->_skip_useless_domains=0;
	}
	cout << "Write database name" << endl;
	cin >> this->_name;
	datalite db(_name + ".sqlite");
	db.export_dl();
	cout << "Write maximum amount of consecutives fails" << endl;
	cin >> this->_max_fails;

	cout << "Write maximum URL length" << endl;
	cin >> this->_max_url_size;

	cout << "Write minimum URL length" << endl;
	cin >> this->_min_url_size;

	cout << "Write maximum description length" << endl;
	cin >> this->_description_max_length;

	cout << "Write maximum title length" << endl;
	cin >> this->_title_max_length;

	cout << "Write maximum useless pages" << endl;
	cin >> this->_max_useless_pages;

	cout << "Write minimum url found" << endl;
	cin >> this->_min_url_found;

	cout << "Write minimum paragraph length" << endl;
	cin >> this->_paragraph_max_length;

	cout << "Write delay between URLs" << endl;
	cin >> this->_delay;

	cout << "Save URL with a defined string" << endl;
	cout << "0.- No"<< endl;
	cout << "1.- Yes"<< endl;
	int lock;
	cin >> lock;
	if(lock == 1){
		cout << "Write that string" << endl;
		cin >> _locked;
	}else{
		this->_locked="";
	}

}

void spidey::crawl(){
	datalite database;
	database.set_file(_name + ".sqlite");
	database.import_dl(_name + ".config");
	int fails = 0;
	int worthless_pages = 0;
	string domain;
	while(database.is_valid_line() && _is_crawling && _max_fails < fails){

		string url = database.get_new_line();
		if(_verbose)
			cout << "page: "<< url <<endl;
		uri base(url);
		database.insert_row(base.scheme() + base.authority() + "/robots.txt", "");
		int inserted_urls = 0;
		if(_skip_useless_domains && worthless_pages > _max_useless_pages){
			while(domain == base.authority() && database.is_valid_line()){
				url = database.get_new_line();
				base = uri(url);
			}
		}
		try{
		  	if(_delay > 0)
				this_thread::sleep_for(chrono::seconds(_delay));
			page download_page(base.to_string(), get_description_max_length(),
				get_title_max_length(), get_paragraph_max_length());
			download_page.set_delimiter(delimiter("<meta name=\"description\" content=\"", "\"", 2));
			download_page.set_delimiter(delimiter("<meta property=\"og:description\" content=\"", "\"", 2));
			download_page.set_delimiter(delimiter("<title>", "</title>", 1));
			while(download_page.has_next_line()){
				try {
					pair<string,string> link_and_caption = download_page.next_link();
					int link_size = link_and_caption.first.size();
					if(link_size > 0 && link_size < _max_url_size && 
						link_size > _min_url_size ){
						uri full(url, link_and_caption.first);
						string full_s = full.to_string();
						if(!is_banned(full.authority()) && !is_locked(full_s)){
							if(_verbose)
								cout << full_s << endl;
							if(database.insert_row(full_s, link_and_caption.second) == 1)
								++inserted_urls;
							database.export_dl(_name + ".config");
							if(fails > 0) fails = 0;
						}
					}
				}catch(page::Invalid e){
					save_log(e.reason());
					if(_max_fails > -1) ++fails;
				}catch(uri::Invalid e){
					save_log(e.reason());
					if(_max_fails > -1) ++fails;
				}
			}
			
			string title = download_page.get_title();
			if(title.size() > 0) database.update_title(title);
			string metainfo = download_page.get_metainfo();
			if(metainfo.size() > 0) database.update_metainfo(metainfo);
			if(_skip_useless_domains){
				if(inserted_urls > _min_url_found){
					worthless_pages = 0;
					domain.clear();
				} else {
					if(domain == base.authority()) {
						++worthless_pages;
					} else {
						worthless_pages = 0;
						domain = base.authority();
					}
				}
			}
		}catch(page::Invalid e){
			cout << "Bad page\nReason: " << e.reason() <<endl;
			if(_max_fails > -1) ++fails;
		}
	}
}
void spidey::thread_crawl(){
	thread (&spidey::crawl, this).detach();
}
void spidey::save(){
	ofstream save("seer.conf");
	save << "name:" << this->_name << endl;
	save << "max_url_size:" << to_string(this->_max_url_size) << endl;
	save << "min_url_size:" << to_string(this->_min_url_size) << endl;
	save << "description_max_length:" << to_string(this->_description_max_length) << endl;
	save << "title_max_length:" << to_string(this->_title_max_length) << endl;
	save << "max_useless_pages:" << to_string(this->_max_useless_pages) << endl;
	save << "min_url_found:" << to_string(this->_min_url_found) << endl;
	save << "paragraph_max_length:" << to_string(this->_paragraph_max_length) << endl;
	save << "delay:" << to_string(this->_delay) << endl;
	save << "daemon:" << to_string(this->_is_daemon) << endl;
	save << "skip_useless_domains:" << to_string(this->_is_daemon) << endl;
	save << "is_crawling:" << to_string(this->_is_crawling) << endl;
	save << "verbose:" << to_string(this->_verbose) << endl;
	save << "max_fails:" << to_string(this->_max_fails) << endl;
	save << "locked:" << this->_locked << endl;
	save.close();
}
void spidey::save_log(const string& log){
	string file = _name + ".log";
	ofstream save(file, ofstream::ate);
	save << log << endl;
	save.close();
}
void spidey::load(){
	ifstream queue_saved("seer.conf");
	string line;
	while(getline(queue_saved,line)){
		size_t points=line.find(":");
		string option=line.substr(0,points);
		size_t nm=option.find("name");
		if(nm!= std::string::npos){
			line=line.substr(++points);
			this->_name= line;
		}
		size_t max=option.find("max_url_size");
		if(max!= std::string::npos){
			line=line.substr(++points);
			this->_max_url_size= stoi(line);
		}
		size_t min=option.find("min_url_size");
		if(min!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_min_url_size= stoi(line);
		}
		size_t dml=option.find("description_max_length");
		if(dml!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_description_max_length= stoi(line);
		}
		size_t tml=option.find("title_max_length");
		if(tml!= std::string::npos){
			line=line.substr(++points);
			this->_title_max_length= stoi(line);
		}
		size_t mup=option.find("max_useless_pages");
		if(mup!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_max_useless_pages= stoi(line);
		}
		size_t muf=option.find("min_url_found");
		if(muf!= std::string::npos){
			line=line.substr(++points);
			this->_min_url_found= stoi(line);
		}
		size_t pml=option.find("paragraph_max_length");
		if(pml!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_paragraph_max_length= stoi(line);
		}
		size_t sud=option.find("skip_useless_domains");
		if(sud!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_skip_useless_domains= stoi(line);
		}
		size_t ic=option.find("is_crawling");
		if(ic!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_is_crawling= stoi(line);
		}
		size_t vb=option.find("verbose");
		if(vb != std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_verbose= stoi(line);
		}
		size_t de=option.find("delay");
		if(de!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_delay= stoi(line);
		}
		size_t d=option.find("daemon");
		if(d!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_is_daemon= stoi(line);
		}
		size_t mf=option.find("max_fails");
		if(mf!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_max_fails= stoi(line);
		}
		size_t lcd=option.find("locked");
		if(lcd!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->_locked= line;
		}
	}
	queue_saved.close();
}
bool spidey::is_banned(const string& word){
	size_t last_point = word.rfind('.');
	bool is_banned = false;
	if(last_point != string::npos){
		size_t second_to_last_point = word.rfind('.', last_point - 1);
		if(second_to_last_point != string::npos){
			string domain = word.substr(second_to_last_point + 1,
				last_point - second_to_last_point - 1);
			is_banned = (_banned.find(domain) != _banned.end());
		}else{
			string domain = word.substr(2,last_point - 2);
			is_banned = (_banned.find(domain) != _banned.end());
		}
	}
	return is_banned;
}

bool spidey::is_locked(const string& line){
	size_t lock = line.find(_locked);
	return (lock == string::npos);
}
			
