#ifndef __SPIDEY__
#define __SPIDEY__
#include <string>
#include <vector>
#include <unordered_set>
#include "delimiter.h"
using namespace std;
class spidey{
	string _name;
	string _locked;

	int _max_fails;
	int _max_url_size;
	int _min_url_size;
	int _description_max_length;
	int _title_max_length;
	int _paragraph_max_length;
	int _delay;
	int _max_useless_pages;
	int _min_url_found;

	unordered_set<string> _banned;

	bool _verbose;
	bool _is_crawling;
	bool _is_daemon;
	bool _skip_useless_domains;
	public:
		spidey(): _name("sq1"), _locked(""), _max_fails(-1), _max_url_size(220)
			, _min_url_size(10), _description_max_length(170)
			,_title_max_length(170), _paragraph_max_length(130)
			,_delay(0), _max_useless_pages(3), _min_url_found(3)
			,_verbose(true), _is_crawling(true)
			,_is_daemon(false), _skip_useless_domains(true){}
		void first_link(const string& link);
		void create_new();
		void crawl();
		void thread_crawl();
		void save();
		void save_log(const string& log);
		void load();
		vector<delimiter> create_delimiters();
		void set_name(const string& file){ _name = file; }
		void set_lock_domain(const string& lock){ _locked = lock; }
		void set_daemon(bool daemon){ _is_daemon = daemon; }
		void set_max_fails(int max_fails){ _max_fails = max_fails; }
		void set_description_max_length(int description_max_length){
			_description_max_length = description_max_length;
		}
		void set_title_max_length(int title_max_length){
			_title_max_length = title_max_length;
		}
		void set_paragraph_max_length(int paragraph_max_length){
			_paragraph_max_length = paragraph_max_length;
		}
		int get_description_max_length(){ return _description_max_length; }
		int get_title_max_length(){ return _title_max_length; }
		int get_paragraph_max_length(){ return _paragraph_max_length; }
		void set_minimum_url_length(int min_url_length){ _min_url_size = min_url_length; }
		void set_maximum_url_length(int max_url_length){ _max_url_size = max_url_length; }
		void set_verbose(bool verbose){ _verbose = verbose; }
		void set_crawling_mode(bool is_crawling){ _is_crawling = is_crawling;}
		void set_skip_useless_domains(bool skip_useless_domains){ _skip_useless_domains = skip_useless_domains;}
		void ban_word(const string& word){ _banned.insert(word); }
		bool is_banned(const string& word);
		bool is_locked(const string& line);
		bool is_loadable();
		string get_name(){ return _name; }
		string get_lock(){ return _locked; }
		int get_max_fails(){ return _max_fails; }
		int get_minimum_url_length(){ return _min_url_size; }
		int get_maximum_url_length(){ return _max_url_size; }
		bool get_verbose(){ return _verbose; }
		bool get_crawling_mode(){ return _is_crawling; }
		bool get_daemon(){ return _is_daemon; }
		bool get_skip_useless_domains(){ return _skip_useless_domains; }
};
#endif
