/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#ifndef CLASE_PRINCIPAL5
#define CLASE_PRINCIPAL5
#include <string>
#include <unordered_set>
#include <map>
struct sq{
	sq();
	~sq();
	
	std::unordered_set<std::string> banned;
	//std::unordered_set<std::string> links;
	
	std::string name;
	std::string url;
	std::string domain;
	std::string alternative;
	std::string title;
	
	int max_url_size;
	//int64_t max_urls;
	int min_url_size;
	int ssl_strict;
	int verbose;
	int64_t position;
	int64_t position_w;
	int control;
	int delay;
	int faster;
	int lock;
	int daemon;
	int max_fails;
	
	std::string isCrawling;
	std::string locked;

	void crawl_bucle();
	void load_config();
	void thread_crawl();
	void load_set();
	void limit_queue();
	void parse_robot(std::string data,std::string url);
	void parse(std::string data, std::string url=" ");
	void double_points(std::string& link,std::string url);
	int retrieve_html(const char * url);
	void retrieve_robot(const char * url);
	void delete_formats(std::string& link);
	std::string previous_folder(std::string& link);
	void comparing(std::string& link);
	void delete_html(std::string& link);
	std::string obtain_domain(std::string& link);
	void insert_link(std::string& link);
	void cleaning_queue();
	void getting_text(std::string&, int number);
	void cleaning_file(int number);
	void root_folder(std::string& link);
	void folder_up(std::string& link);
	void create_sq();
	void load_sq();
	void change_sq();
	void mix_sq();
	void indexing_domains();
	void searching_domains(std::map<std::string, std::string>& mymap);
	void import_bookmarks();
};
#endif
