/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <sqlite3.h>
#include <string>
#include <stdint.h>
#include "sql.h"
using namespace std;
static int callback(void *NotUsed, int argc, char **argv, char **azColName){
	int i;
	for(i=0; i<argc; i++){
		printf("%s = %s\n", azColName[i], argv[i] ? argv[i] : "NULL");
	}
	printf("\n");
	return 0;
}
int sqlite_insert( string link, string title, string db){
	sqlite3 *sq;
	int rc;
	sqlite3_stmt * stmt;
	std::string sql;
	/* Open database */
	rc = sqlite3_open(db.c_str(), &sq);
	if(rc){
		fprintf(stderr, "Can't open database: %s\n", sqlite3_errmsg(sq));
		sqlite3_finalize(stmt);
		sqlite3_close(sq);
		return 1 ;
	}else{
		fprintf(stderr, "Opened database successfully\n");
		sql = "INSERT INTO COB VALUES ('";
		sql+=link+"', ' ');";

		std::cout << sql << std::endl;

		sqlite3_prepare(sq,sql.c_str(),-1,&stmt,NULL);
		sqlite3_step( stmt );//executing the statement
		sqlite3_finalize(stmt);
		sqlite3_close(sq);
		return 0;
	}

}

int sqlite_create(string db){
	sqlite3 *sq;
	char *zErrMsg = 0;
	int  rc;
	string sql;

	/* Open database */
	rc = sqlite3_open(db.c_str(), &sq);
	/* Create SQL statement */
	sql ="DROP TABLE IF EXISTS COB; \
	CREATE TABLE COB(    \
	LINK TEXT NOT NULL UNIQUE, \
	TITLE TEXT NOT NULL \
);";

	/* Execute SQL statement */
	rc = sqlite3_exec(sq, sql.c_str(), callback, 0, &zErrMsg);
	if( rc != SQLITE_OK ){
		sqlite3_free(zErrMsg);
	}
	sqlite3_close(sq);
	return 0;
}

int sqlite_select(int64_t key, string db, string& link){

	sqlite3 *sq;
	char *err_msg = 0;
	sqlite3_stmt *res;
	char sql[10000];
	int rc = sqlite3_open(db.c_str(), &sq);
	if (rc) {
		fprintf(stderr, "Cannot open database: %s\n", sqlite3_errmsg(sq));
		sqlite3_close(sq);
		return 1;
	}

	sprintf(sql,"SELECT LINK FROM COB WHERE rowid='%li'",key);

	rc = sqlite3_prepare_v2(sq, sql, -1, &res, 0);
	if (rc == SQLITE_OK) {
		int step = sqlite3_step(res);

		const char * retri=(char *) sqlite3_column_text(res,0);
		if(retri != NULL){
			std::string text(retri);
			link=text;
		}
	} else {

		fprintf(stderr, "Failed to execute statement: %s\n", sqlite3_errmsg(sq));
		return 1;
	}

	sqlite3_finalize(res);
	sqlite3_close(sq);
	return 0;
}

int sqlite_se(string db, string& link){
	sqlite3 *sq;
	char *err_msg = 0;
	sqlite3_stmt *res;
	std::string sql;
	int rc = sqlite3_open(db.c_str(), &sq);

	if (rc){
		fprintf(stderr, "Cannot open database: %s\n", sqlite3_errmsg(sq));
		sqlite3_close(sq);
		return 1;
	}

	sql="SELECT LINK FROM COB WHERE LINK LIKE '%"+link+"%'";
	rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
	if (rc == SQLITE_OK) {
		int idx = sqlite3_bind_parameter_index(res, "@id");
		int value = 4;
		sqlite3_bind_int(res, idx, value);
		 int step = sqlite3_step(res);
		while (step == SQLITE_ROW) {
			printf("%s\n",sqlite3_column_text(res, 0));
			step = sqlite3_step(res);
		} 
	} else {
		fprintf(stderr, "Failed to execute statement: %s\n", sqlite3_errmsg(sq));
	}
	
	
	sqlite3_finalize(res);
	sqlite3_close(sq);
	return 0;
}
int sqlite_up(string db, int64_t position, string title){
	sqlite3 *sq;
	char *err_msg = 0;
	sqlite3_stmt *res;
	int rc = sqlite3_open(db.c_str(), &sq);
	if (rc) {
		fprintf(stderr, "Cannot open database: %s\n", sqlite3_errmsg(sq));
		sqlite3_close(sq);
		return 1;
	}

	std::string sql;
	std::string s = std::to_string(position);
	sql = "UPDATE COB SET TITLE = '"+title+"' where rowid="+s;
	rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
	if (rc == SQLITE_OK){
		int step = sqlite3_step(res);

		
	} else {

		fprintf(stderr, "Failed to execute statement: %s\n", sqlite3_errmsg(sq));
		return 1;
	}
	sqlite3_finalize(res);
	sqlite3_close(sq);
}
