/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <sqlite3.h>
#include <string>
#include "sql.h"
using namespace std;
static int callback(void *NotUsed, int argc, char **argv, char **azColName){
	return 0;
}
/*
 * Return:
 * 0 : failed
 * 1 : OK
 * 2 : inserted before
 */
int sqlite_insert( string link, string title, string db){
	sqlite3 *sq;
	int rc = sqlite3_open(db.c_str(), &sq);
	int result=0;

	if (!rc){
		sqlite3_stmt *res;
		string sql = "INSERT INTO COB VALUES ('";
		sql+=link+"', '"+title+"');";
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);
		if (rc == SQLITE_OK) {
			int step=sqlite3_step(res);
			if(step == SQLITE_CONSTRAINT)
				result=2;
			else if(step == SQLITE_DONE)
				result=1;
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}
/*
 * Return:
 * 0 : failed
 * 1 : OK
 */
int sqlite_create(string db){
	sqlite3 *sq;
	int rc = sqlite3_open(db.c_str(), &sq);
	int result=0;

	if (!rc){
		char *zErrMsg = 0;
		string sql ="DROP TABLE IF EXISTS COB; \
			CREATE TABLE COB(    \
			LINK TEXT NOT NULL UNIQUE, \
			TITLE TEXT \
			);";
		rc = sqlite3_exec(sq, sql.c_str(), callback, 0, &zErrMsg);
		if (rc == SQLITE_OK)
			result=1;
		else
			sqlite3_free(zErrMsg);
	}
	sqlite3_close(sq);
	return result;
}
/*
 * Return:
 * 0 : failed
 * 1 : OK
 */
int sqlite_select(int64_t key, string db, string& link){

	sqlite3 *sq;
	int rc = sqlite3_open(db.c_str(), &sq);
	int result=0;

	if (!rc){
		
		sqlite3_stmt *res;
		string sql="SELECT LINK FROM COB WHERE rowid="+to_string(key);
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);

		if (rc == SQLITE_OK) {
			sqlite3_step(res);

			const char * retri=(char *) sqlite3_column_text(res,0);
			if(retri != NULL){
				
				link=string(retri);
				result=1;
			}
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}
/*
 * Return:
 * 0 : failed
 * 1 : OK
 */
int sqlite_se(string db, string link){

	sqlite3 *sq;
	int rc = sqlite3_open(db.c_str(), &sq);
	int result=0;

	if (!rc){
		sqlite3_stmt *res;
		string sql="SELECT LINK FROM COB WHERE LINK LIKE '%"+link+"%' OR TITLE LIKE '%"+link+"%';";
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);

		if (rc == SQLITE_OK) {
			int idx = sqlite3_bind_parameter_index(res, "@id");
			int value = 4;
			sqlite3_bind_int(res, idx, value);
			int step = sqlite3_step(res);
			int option;
			do{

				int i=0;
				while (step == SQLITE_ROW && i<10) {
					printf("%s\n",sqlite3_column_text(res, 0));
					step = sqlite3_step(res);
					++i;
				}
				cout << "¿Quiere obtener los siguientes 10 resultados?\n1.- Si\n2.-No" << endl;
				cin >> option;

			}while(option==1 && step==SQLITE_ROW);
			result=1;
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}
/*
 * Return rowid if worked and -1 if doesn't
 *
 */
int64_t sqlite_rowid(string db){
	sqlite3 *sq;
	int rc = sqlite3_open(db.c_str(), &sq);
	int64_t result=-1;

	if (!rc){
		sqlite3_stmt *res;
		string sql="SELECT rowid FROM COB WHERE rowid=(SELECT MAX(rowid) FROM COB)";
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);

		if (rc == SQLITE_OK) {
			sqlite3_step(res);

			const char * retri=(char *) sqlite3_column_text(res,0);
			if(retri != NULL){
				string text(retri);
				result=stoll(text);

			}
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}
/*
 * Return:
 * 0 : failed
 * 1 : OK
 */
int sqlite_up(string db, int64_t position, string title){

	sqlite3 *sq;
	int rc = sqlite3_open(db.c_str(), &sq);
	int result=0;

	if (!rc){
		sqlite3_stmt *res;
		string sql = "UPDATE COB SET TITLE = TITLE || ' ' || '"+title+"' where rowid="+to_string(position);
		rc = sqlite3_prepare_v2(sq, sql.c_str(), -1, &res, 0);

		if (rc == SQLITE_OK) {
			sqlite3_step(res);

			result=1;
		}
		sqlite3_finalize(res);
	}
	sqlite3_close(sq);
	return result;
}
