#include <string>
#include "uri.h"
#include <iostream>
using namespace std;
uri::uri(const string& complete_url){
	size_t colon=complete_url.find(':');
	++colon;
	if(colon!=string::npos)
		scheme_=complete_url.substr(0,colon);
	else
		throw Invalid("There isn't any scheme "+complete_url);

	size_t double_slash=complete_url.find("//");
	if(double_slash!=string::npos){
		double_slash+=2;
		string aux=complete_url.substr(double_slash,complete_url.size()-double_slash);
		size_t slash=aux.find('/');
		if(slash!=string::npos){
			authority_="//"+aux.substr(0,slash);
			if(slash!=aux.size()){
				if(aux[slash]!='?'){
					size_t quest=aux.find('?');
					if(quest!=string::npos){
						path_=aux.substr(slash,quest-slash);
						path_=delete_slug(path_);
					}else{
						path_=aux.substr(slash,aux.size()-slash);
						path_=delete_slug(path_);
					}
				}else{
					path_="/";
				}
			}else{
				path_="/";
			}
		}else
			path_="/"; //invalid path
	}else{
		size_t slash=complete_url.find('/');
		if(slash!=string::npos){
			size_t quest=complete_url.find('?');
			if(quest==string::npos){
				path_=complete_url.substr(slash,complete_url.size()-slash);
				path_=delete_slug(path_);
			}else{
				path_=complete_url.substr(slash,complete_url.size()-quest);
				path_=delete_slug(path_);
			}
		}else
			path_="/"; //invalid path
	}
}
string uri::delete_slug(string path){
	size_t slash=path.rfind('/');
	++slash;
	if(slash!=string::npos){
		if(slash!=path.size()-1){
			path=path.substr(0,slash);
		}
	}
	return path;
}
string uri::delete_directory(string path){
	size_t slash=path.rfind('/');
	if(slash!=string::npos){
		size_t next_slash=path.rfind('/',slash+1);
		if(next_slash!=string::npos){

				path=path.substr(0,next_slash+1);
		
		}
	}
	return path;
}
string uri::input(const string& input){
	string new_page;
	if(input.size()>0){
		if(input[0]=='.'){
			size_t i=0;
			string path=path_;
			while(i<input.size() && input[i]=='.'){
				if(i+1<input.size() && input[i+1]=='.'){
					if(i+2<input.size() && input[i+2]=='/'){
						size_t slash=path.rfind('/',path.size()-2);
						if(slash!=string::npos){
							path=path.substr(0,slash+1);
						}
						i+=3;
					}else{
						size_t slash=path.rfind('/',path.size()-2);
						if(slash!=string::npos){
							path=path.substr(0,slash+1);
						}
						i+=2;
					}
				}else if(i+1<input.size() && input[i+1]=='/'){
					i+=2;
				}else{
					throw Invalid("There isn't any slash "+input);
				}
			}
			new_page=scheme_+authority_+path+input.substr(i,input.size()-i);
		}else if(input[0]=='/' && input[1]=='/'){
			new_page = scheme_ + input;
		}else if(input[0]=='/'){
			new_page =scheme_+authority_+input;
		}else{
			size_t colon_t = input.find(':');
			if(colon_t!=string::npos)
				new_page = input;
			else
				new_page = scheme_+authority_+path_+input;
		}
	}
	return new_page;		

}
