#include <string>
#include "uri.h"
#include <iostream>
using namespace std;
uri::uri(const string& complete_url){
	size_t colon=complete_url.find(':');
	if(colon!=string::npos){
		++colon;
		scheme_ = complete_url.substr(0,colon);
	}else
		throw Invalid("Couldn't find URI scheme "+complete_url);

	size_t double_slash = complete_url.find("//");
	if(double_slash != string::npos){
		double_slash += 2;
		string aux = complete_url.substr(double_slash);
		size_t slash = aux.find('/');
		if(slash != string::npos){
			authority_ = "//" + aux.substr(0,slash);
			if(slash != aux.size()){
				if(aux[slash] != '?'){
					size_t quest=aux.find('?');
					slash = aux.find('/');
					if(quest!=string::npos){
						slug_=aux.substr(slash,quest-slash);
						path_=delete_slug(slug_);
						size_t last_slash=slug_.rfind('/');
						++last_slash;
						slug_=slug_.substr(last_slash, slug_.size()-last_slash);
						size_t hash = aux.find('#');
						if(hash != string::npos)
							query_ = aux.substr(quest, hash - quest);
						else
							query_ = aux.substr(quest);
						
					}else{
						slug_=aux.substr(slash,aux.size()-slash);
						path_=delete_slug(slug_);
						size_t last_slash=slug_.rfind('/');
						++last_slash;
						slug_=slug_.substr(last_slash, quest-last_slash);
					}
				}else{
					path_="/";
				}
			}else{
				path_="/";
			}
		}else{
			authority_="//" + aux;
			path_="/"; //invalid path
		}
	}else{
		throw Invalid("Couldn't find URI scheme "+complete_url);
	}
}
uri::uri(const string& base_url, const string& relative){
	uri temp(base_url);
	uri temp2(temp.input(relative));
	scheme_ = temp2.scheme();
	authority_ = temp2.authority();
	path_ = temp2.path();
	slug_ = temp2.slug();
	query_ = temp2.query();
}
string uri::delete_slug(string path){
	size_t slash=path.rfind('/');
	++slash;
	if(slash!=string::npos){
		if(slash!=path.size()-1){
			path=path.substr(0,slash);
		}
	}
	return path;
}
string uri::delete_directory(string path){
	size_t slash=path.rfind('/');
	if(slash!=string::npos){
		size_t next_slash=path.rfind('/',slash+1);
		if(next_slash!=string::npos)
			path=path.substr(0,next_slash+1);

		
	}
	return path;
}
/*
 * Error: line size = 0
 * Success: line size > 0
 *
 */
 
string uri::input(const string& input){
	string new_page;
	if(input.size()>0){
		if(input[0]=='.'){
			size_t i=0;
			string path=path_;
			while(i<input.size() && input[i]=='.'){
				if(i+1<input.size() && input[i+1]=='.'){
					if(i+2<input.size() && input[i+2]=='/'){
						size_t slash=path.rfind('/',path.size()-2);
						if(slash!=string::npos){
							path=path.substr(0,slash+1);
						}
						i+=3;
					}else{
						size_t slash=path.rfind('/',path.size()-2);
						if(slash!=string::npos){
							path=path.substr(0,slash+1);
						}
						i+=2;
					}
				}else if(i+1<input.size() && input[i+1]=='/'){
					i+=2;
				}else{
					throw Invalid("Couldn't find slash "+input);
				}
			}
			new_page=scheme_+authority_+path+input.substr(i,input.size()-i);
		}else if(input[0]=='/' && input[1]=='/'){
			new_page = scheme_ + input;
		}else if(input[0]=='/'){
			new_page =scheme_+authority_+input;
		}else if(input[0]=='?'){
			size_t hash = input.find('#');
			string query = input;
			if(hash != string::npos)
				query = input.substr(0, hash);
			new_page = scheme_ + authority_ + path_ + slug_ + query;

		}else{
			size_t colon_t = input.find(':');
			if(colon_t < 8 && colon_t > 1){
				if(input.find("file") != string::npos)	
					new_page = input;
				else{
					size_t slashes = input.find("//");
					if(slashes != string::npos)
						new_page = input;
				}
			}else
				if(colon_t == string::npos or colon_t > 20)
					new_page = scheme_ + authority_ + path_ + input;
		}
	}
	return new_page;		

}
