#ifndef __URI__
#define __URI__
#include <string>
using namespace std;
class uri{
	public:
		uri(const string& complete_url);
		uri(const string& base_url, const string& relative);
		bool valid() const;
		string delete_slug(string path);
		string delete_directory(string path);
		string input(const string& input);
		string scheme() const{return scheme_;};
		string authority() const{return authority_;};
		string path() const{return path_;};
		string slug() const{return slug_;};
		string query() const{return query_;};
		string to_string(){ return scheme_ + authority_ + path_ + slug_ + query_; }
		struct Invalid{
			Invalid(const string& reason):reason_(reason){}
			string reason()const{return reason_;}
			private:
				string reason_;
		};
	private:
		string scheme_;
		string authority_;
		string path_;
		string slug_;
		string query_;
};
#endif