
#include "SDL.h"
#include "SDL_image.h"

const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;

//La ventana que crearemos
SDL_Window* gWindow = NULL;
SDL_Texture* mTexture;
//La superficie que contiene la ventana
SDL_Renderer* gRenderer = NULL;
SDL_Surface* gTest = NULL;

int main( int argc, char* args[] )
{
	//Comprueba si se inicia SDL
	if( SDL_Init( SDL_INIT_VIDEO ) < 0 )
	{
		printf( "No se inició SDL. %s\n", SDL_GetError() );
	}
	else
	{
		//Crea una ventana
		gWindow = SDL_CreateWindow( "Comprueba la instalación", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN );
		//Comprueba la creación de la ventana
		if( gWindow == NULL )
		{
			printf( "La ventana no se inició. %s\n", SDL_GetError() );
		}
		else
		{
			//Crea el render
			gRenderer = SDL_CreateRenderer( gWindow, -1, SDL_RENDERER_PRESENTVSYNC);
			//Comprueba la creación de la ventana
			if( gRenderer==NULL ){
				printf( "El render no se inició. %s\n", SDL_GetError() );
			}
		}
	}
	//Carga la imagen
	gSurface = IMG_Load( "comprueba.png" );
	//Comprueba la carga de la imagen
	if( gTest == NULL )
	{
		printf( "No se ha podido cargar la imagen %s! %s\n", "comprueba.png", SDL_GetError() );
	}
	//Superficie a textura
	mTexture = SDL_CreateTextureFromSurface( gRenderer, gTest );
	SDL_RenderCopy( gRenderer, mTexture, NULL, NULL );
	SDL_UpdateWindowSurface( gWindow );
	SDL_RenderPresent( gRenderer );
	SDL_Delay( 2000 );

	//Libera los recursos
	SDL_FreeSurface( gTest );
	gTest = NULL;
	SDL_DestroyWindow( gWindow );
	gWindow = NULL;
	SDL_Quit();
}

