#include "SDL.h"
#include "SDL_image.h"
#include <iostream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
const int JOYSTICK_DEAD_ZONE = 8000;
SDL_Renderer *gRenderer = NULL;
SDL_Joystick* gGameController = NULL;
SDL_Texture* mTexture = NULL;
SDL_Window * gWindow = NULL;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_VIDEO | SDL_INIT_JOYSTICK );
	SDL_GameController *controller = NULL;
	//Número de joysticks
	if( SDL_NumJoysticks() < 1 )
		printf( "No se han detectado joysticks\n" );
	//Inicia el joystick
	gGameController = SDL_JoystickOpen(0);
	gWindow = SDL_CreateWindow( "Pruebas con joysticks", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN );
	gRenderer=SDL_CreateRenderer(gWindow,-1,0);

	SDL_Surface * loadedSurface = IMG_Load("flecha.png");
	
	//Color para el píxel transparente
	SDL_SetColorKey( loadedSurface, SDL_TRUE, SDL_MapRGB( loadedSurface->format, 0, 0xFF, 0xFF ) );

	mTexture = SDL_CreateTextureFromSurface( gRenderer, loadedSurface );

	bool quit = false;
	SDL_Event e;

	int xDir = 0;
	int yDir = 0;

	while( !quit ){
	//Eventos en la cola
		while( SDL_PollEvent( &e ) != 0 ){
			//User requests quit
			if( e.type == SDL_QUIT ){
				quit = true;
			}
			else if( e.type == SDL_JOYAXISMOTION ){
					//Movimiento en el joystick
					if( e.jaxis.which == 0 ){						
						//Movimiento en el eje X
						if( e.jaxis.axis == 0 ){
							//Movimiento en la izquierda (negativo)
							if( e.jaxis.value < -JOYSTICK_DEAD_ZONE ){
								xDir = -1;
							}
							//Movimiento en la derecha (positivo)
							else if( e.jaxis.value > JOYSTICK_DEAD_ZONE ){
								xDir =  1;
							}else{
								xDir = 0;
							}
						}
						//Movimiento en el eje Y
						else if( e.jaxis.axis == 1 ){
							//Movimiento hacia abajo (negativo)
							if( e.jaxis.value < -JOYSTICK_DEAD_ZONE ){
								yDir = -1;
							}
							//Movimiento hacia arriba (positivo)
							else if( e.jaxis.value > JOYSTICK_DEAD_ZONE ){
								yDir =  1;
							}else{
								yDir = 0;
							}
						}
					}
				}
			}
			SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
			SDL_RenderClear( gRenderer );
			//Cálculo del ángulo
			double joystickAngle = atan2( (double)yDir, (double)xDir ) * ( 180.0 / M_PI );
			//Correción del ángulo
			if( xDir == 0 && yDir == 0 ){
				joystickAngle = 0;
			}
			//Posición en X del rectángulo que contiene a la imagen.
			int x=( SCREEN_WIDTH - 320 ) / 2;
			//Posición en Y del rectángulo que contiene a la imagen.
			int y=( SCREEN_HEIGHT - 240 ) / 2;
			
			SDL_Rect renderQuad = { x, y, 320, 240 };
			//Punto del centro
			SDL_Point* center = NULL;
			//Ningún giro ni opción especial.
			SDL_RendererFlip flip = SDL_FLIP_NONE;
			//Renderizar con giro del joystick
			SDL_RenderCopyEx( gRenderer, mTexture, NULL, &renderQuad, joystickAngle, center, flip );
			//Actualizar pantalla
			SDL_RenderPresent( gRenderer );
			}
		}
		
	
