#include "SDL.h"
#include "SDL_ttf.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;

SDL_Renderer* gRenderer = NULL;
SDL_Joystick* gGameController = NULL;
SDL_Texture* mTexture = NULL;
SDL_Window * gWindow = NULL;
TTF_Font* gFont = NULL;

int main(int argc, char* argv[]){
	//Iniciamos SDL
	SDL_Init( SDL_INIT_EVERYTHING);
	//Iniciamos True Type Font
	TTF_Init();
	gWindow = SDL_CreateWindow( "Tiempo desde que se inició", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN );
	gRenderer=SDL_CreateRenderer(gWindow,-1,0);
	//Carga de la fuente de letra
	gFont = TTF_OpenFont( "tnfc.ttf", 28 );
	//Inicia el SDL_Event
	SDL_Event e;
	//Color del texto con SDL_Color {R,G,B,A}
	SDL_Color textColor = { 0, 0, 0, 255 };
	//Controla el tiempo y lo almacena
	Uint32 startTime = 0;
	//Almacena el texto
	std::stringstream timeText;
	bool quit = false;
	while( !quit ){
		while( SDL_PollEvent( &e ) != 0 ){
			if( e.type == SDL_QUIT ){
				quit = true;
			}else if( e.type == SDL_KEYDOWN && e.key.keysym.sym == SDLK_RETURN ){
						startTime = SDL_GetTicks();
					
			}
		}
		
		timeText.str( "" );
		timeText << "Milisegundos contados " << SDL_GetTicks() - startTime; 
		const SDL_Point center={200,200};
		//Superficie del texto renderizado
		SDL_Surface* textSurface = TTF_RenderText_Solid( gFont, timeText.str().c_str(), textColor );
		//De superficie a textura
		mTexture = SDL_CreateTextureFromSurface( gRenderer, textSurface);

		SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
		SDL_RenderClear( gRenderer );
		SDL_Rect renderQuad = { ( SCREEN_WIDTH - 320 ) / 2, 0, 400, 100 };
		//Renderizar la textura
		SDL_RenderCopyEx( gRenderer, mTexture, NULL, &renderQuad, 0, &center, SDL_FLIP_NONE );
		SDL_RenderPresent( gRenderer );
			
		
	}
}
	
