#include "SDL.h"
#include "SDL_image.h"
#include "SDL_ttf.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
//Variable para controlar cómo parar
bool mStarted=true;
SDL_Renderer *gRenderer = NULL;
SDL_Texture* mTexture = NULL;
SDL_Window * gWindow = NULL;
TTF_Font *gFont = NULL;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_EVERYTHING);
	TTF_Init();

	SDL_Window * gWindow = SDL_CreateWindow( "FPS mediante SDL", 			SDL_WINDOWPOS_UNDEFINED,
		SDL_WINDOWPOS_UNDEFINED,
		SCREEN_WIDTH,
		SCREEN_HEIGHT,
		SDL_WINDOW_SHOWN );
	//Ventana con VSYNC para caparla a la velocidad de la pantalla
	SDL_Renderer * gRenderer=SDL_CreateRenderer(gWindow,
		-1,SDL_RENDERER_PRESENTVSYNC);

	gFont = TTF_OpenFont( "tnfc.ttf", 28 );
	SDL_Event e;
	
	bool quit = false;
	SDL_Color textColor = { 0, 0, 0, 255 };

	int Frames = 0;
	std::stringstream timeText;

	while( !quit ){
		while( SDL_PollEvent( &e ) != 0 ){
			if( e.type == SDL_QUIT ){
				quit = true;

			}else if( e.type == SDL_KEYDOWN ){
				if( e.key.keysym.sym == SDLK_s ){
					if(mStarted){
						mStarted=false;
					}else{
						mStarted=true;
					}
				}
			}
		}
		int Ticks=0;
		float FPS=0;
		if(mStarted){
			Ticks=SDL_GetTicks();
			//Fotogramas dividido entre el tiempo da los FPS
			FPS = Frames / ( Ticks / 1000. );
			timeText.str( "" );
			timeText << "Promedio de FPS " << FPS;
		}else{
			timeText.str( "" );
			timeText << "Vuelve a pulsar \"S\" para continuar";
		}
		
		SDL_Surface* textSurface = TTF_RenderText_Solid( gFont, timeText.str().c_str(), textColor );

		mTexture = SDL_CreateTextureFromSurface( gRenderer, textSurface);

		SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
		SDL_RenderClear( gRenderer );

		SDL_Rect renderQuad = { ( SCREEN_WIDTH - 300 )/ 2, 0, 400, 80 };
		SDL_Rect * clip=NULL;

		SDL_RenderCopy( gRenderer, mTexture, clip, &renderQuad);
		SDL_RenderPresent( gRenderer );
		++Frames;
	}
}
	
