#include "SDL.h"
#include "SDL_image.h"
#include "SDL_ttf.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
int mPosX=0; 
int mPosY=0;
int mVelX=0; 
int mVelY=0;
static const int DOT_WIDTH = 20;
static const int DOT_HEIGHT = 20;
static const int DOT_VEL = 10;
TTF_Font *gFont = NULL;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_EVERYTHING);
	TTF_Init();
	SDL_Window * gWindow = SDL_CreateWindow( "Cuadrado controlable", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN );

	SDL_Renderer * gRenderer=SDL_CreateRenderer(gWindow,
		-1,
		SDL_RENDERER_PRESENTVSYNC);
	SDL_Event e;
	SDL_Surface * loadedSurface = IMG_Load( "cuadrado.png" );

	SDL_SetColorKey( loadedSurface, SDL_TRUE, SDL_MapRGB( loadedSurface->format, 0, 0xFF, 0xFF ) );

	SDL_Texture * newTexture = SDL_CreateTextureFromSurface( gRenderer, loadedSurface );
		
	bool quit = false;
	SDL_Color textColor = { 0, 0, 0, 255 };
	std::stringstream timeText;

	while( !quit ){
		while( SDL_PollEvent( &e ) != 0 ){
			if( e.type == SDL_QUIT ){
				quit=true;
			}else if( e.type == SDL_KEYDOWN ){
				if( e.key.keysym.sym == SDLK_ESCAPE )
					quit = true;
				
			}
			if( e.type == SDL_KEYDOWN && e.key.repeat == 0 ){
				//Ajusta la velocidad al pulsar una tecla
				switch( e.key.keysym.sym ){
					case SDLK_UP: mVelY -= DOT_VEL; break;
					case SDLK_DOWN: mVelY += DOT_VEL; break;
					case SDLK_LEFT: mVelX -= DOT_VEL; break;
					case SDLK_RIGHT: mVelX += DOT_VEL; break;
				}
			}else if( e.type == SDL_KEYUP && e.key.repeat == 0 ){
				//Ajusta la velocidad al soltar una tecla
				switch( e.key.keysym.sym ){
					case SDLK_UP: mVelY += DOT_VEL; break;
					case SDLK_DOWN: mVelY -= DOT_VEL; break;
					case SDLK_LEFT: mVelX += DOT_VEL; break;
					case SDLK_RIGHT: mVelX -= DOT_VEL; break;
				}
			}
		}
		
		mPosX += mVelX;

		if( ( mPosX < 0 ) || ( mPosX + DOT_WIDTH > SCREEN_WIDTH ) ){
			mPosX -= mVelX;
		}
		mPosY += mVelY;

		if( ( mPosY < 0 ) || ( mPosY + DOT_HEIGHT > SCREEN_HEIGHT ) ){
			mPosY -= mVelY;
		}
		SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
		SDL_RenderClear( gRenderer );
		SDL_Rect renderQuad = { mPosX, mPosY, 20, 20 };
		SDL_RenderCopy( gRenderer, newTexture, NULL, &renderQuad);
		SDL_RenderPresent( gRenderer );
	}
}
		
	
