#include "SDL.h"
#include "SDL_image.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
int mPosX=0; 
int mPosY=0;
SDL_Rect mCollider;
SDL_Rect wall;
SDL_Rect wall2;
static const int DOT_WIDTH = 20;
static const int DOT_HEIGHT = 20;
static const int DOT_VEL = 10;
int mVelX=0; 
int mVelY=0;
SDL_Texture * newTexture=NULL;
SDL_Renderer * gRenderer = NULL;
SDL_Window * gWindow = NULL;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_EVERYTHING);

	gWindow = SDL_CreateWindow( "Cuadrado y paredes", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN );

	gRenderer=SDL_CreateRenderer(gWindow,-1,SDL_RENDERER_PRESENTVSYNC);

	SDL_Surface* loadedSurface = IMG_Load( "cuadrado.png" );
	
	SDL_SetColorKey( loadedSurface, SDL_TRUE, SDL_MapRGB( loadedSurface->format, 0, 0xFF, 0xFF ) );

	newTexture = SDL_CreateTextureFromSurface( gRenderer, loadedSurface );

	bool quit = false;
	SDL_Event e;
	SDL_Color textColor = { 0, 0, 0, 255 };

	Uint32 startTime = 0;
	int Frames = 0;

	std::stringstream timeText;
	//Pared teórica
	wall.x = 300;
	wall.y = 40;
	wall.w = 40;
	wall.h = 400;
	//Pared visual
	wall2.x = 320;
	wall2.y = 60;
	wall2.w = 20;
	wall2.h = 380;
	while( !quit ){
		while( SDL_PollEvent( &e ) != 0 ){

			if( e.type == SDL_KEYDOWN ){

				if( e.key.keysym.sym == SDLK_ESCAPE ){
					quit = true;
				}
			}
			if( e.type == SDL_KEYDOWN && e.key.repeat == 0 ){

				switch( e.key.keysym.sym ){
					case SDLK_UP: mVelY -= DOT_VEL; break;
					case SDLK_DOWN: mVelY += DOT_VEL; break;
					case SDLK_LEFT: mVelX -= DOT_VEL; break;
					case SDLK_RIGHT: mVelX += DOT_VEL; break;
				}
			}else if( e.type == SDL_KEYUP && e.key.repeat == 0 ){

				switch( e.key.keysym.sym ){
					case SDLK_UP: mVelY += DOT_VEL; break;
					case SDLK_DOWN: mVelY -= DOT_VEL; break;
					case SDLK_LEFT: mVelX += DOT_VEL; break;
					case SDLK_RIGHT: mVelX -= DOT_VEL; break;
				}
			}
		}
				
		mPosX += mVelX;
		mCollider.x = mPosX;
		//Lados de los rectángulos
		int leftA, leftB;
		int rightA, rightB;
		int topA, topB;
		int bottomA, bottomB;
		bool control=true;
		//Lados del rectángulo A
		leftA = mCollider.x;
		rightA = mCollider.x + mCollider.w;
		topA = mCollider.y;
		bottomA = mCollider.y + mCollider.h;

		//Lados del rectángulo B
		leftB = wall.x;
		rightB = wall.x + wall.w;
		topB = wall.y;
		bottomB = wall.y + wall.h;

		//Si alguna de las paredes de A supera las de B
		if( bottomA <= topB ){
			control = false;
		}
		if( topA >= bottomB ){
			control = false;
		}
		if( rightA <= leftB ){
			control = false;
		}
		if( leftA >= rightB ){
			control= false;
		}
		if( ( mPosX < 0 ) || ( mPosX + DOT_WIDTH > SCREEN_WIDTH ) || control ){
			mPosX -= mVelX;
			mCollider.x = mPosX;
		}
		mPosY += mVelY;
		mCollider.y = mPosY;
			
		control=true;
		//Lados del rectángulo A
		leftA = mCollider.x;
		rightA = mCollider.x + mCollider.w;
		topA = mCollider.y;
		bottomA = mCollider.y + mCollider.h;

		//Lados del rectángulo B
		leftB = wall.x;
		rightB = wall.x + wall.w;
		topB = wall.y;
		bottomB = wall.y + wall.h;

		//Si alguna de las paredes de A supera las de B
		if( bottomA <= topB ){
			control = false;
		}
		if( topA >= bottomB ){
			control = false;
		}
		if( rightA <= leftB ){
			control = false;
		}
		if( leftA >= rightB ){
			control= false;
		}
		if(  ( mPosY < 0 ) || ( mPosY + DOT_HEIGHT > SCREEN_HEIGHT ) || control ){
			mPosY -= mVelY;
			mCollider.y = mPosY;
		}
		SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
		SDL_RenderClear( gRenderer );

		SDL_SetRenderDrawColor( gRenderer, 0, 0, 0, 255 );
		//Renderizar un rectángulo que representa las paredes
		SDL_RenderDrawRect( gRenderer, &wall2 );
		SDL_Rect out={mPosX,mPosY,20,20};
		SDL_RenderCopy( gRenderer, newTexture, NULL, &out);
		SDL_RenderPresent( gRenderer );
	}
}
		
	
