#include "SDL.h"
#include "SDL_image.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
int mPosX=0; 
int mPosY=0;
SDL_Rect mCollider;
SDL_Rect wall;
SDL_Rect camera = { 0, 0, 640, 480 };
static const int DOT_WIDTH = 20;
static const int DOT_HEIGHT = 20;
static const int DOT_VEL = 10;
int mVelX=0; 
int mVelY=0;
SDL_Texture * newTexture2=NULL;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_EVERYTHING);
	SDL_Window * gWindow = SDL_CreateWindow( "Fondo de pantalla dinámico", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN );
	SDL_Renderer * gRenderer=SDL_CreateRenderer(gWindow,-1,SDL_RENDERER_PRESENTVSYNC);
	SDL_Surface* loadedSurface = IMG_Load("cuadrado.png");
	SDL_SetColorKey( loadedSurface, SDL_TRUE, SDL_MapRGB( loadedSurface->format, 0, 0xFF, 0xFF ) );

	SDL_Texture * newTexture = SDL_CreateTextureFromSurface( gRenderer, loadedSurface );
	loadedSurface = IMG_Load( "fd.png" );
	SDL_SetColorKey( loadedSurface, SDL_TRUE, SDL_MapRGB( loadedSurface->format, 0, 0xFF, 0xFF ) );
	newTexture2 = SDL_CreateTextureFromSurface( gRenderer, loadedSurface );

	bool quit = false;
	SDL_Event e;
	while( !quit ){
		while( SDL_PollEvent( &e ) != 0 ){
			if( e.type == SDL_QUIT ){
				quit=true;
			}else if( e.type == SDL_KEYDOWN ){
				if( e.key.keysym.sym == SDLK_ESCAPE ){
					quit = true;
				}
			}
		if( e.type == SDL_KEYDOWN && e.key.repeat == 0 ){

			switch( e.key.keysym.sym ) {
				case SDLK_UP: mVelY -= DOT_VEL; break;
				case SDLK_DOWN: mVelY += DOT_VEL; break;
				case SDLK_LEFT: mVelX -= DOT_VEL; break;
				case SDLK_RIGHT: mVelX += DOT_VEL; break;
			}
		}else if( e.type == SDL_KEYUP && e.key.repeat == 0 ){
        	switch( e.key.keysym.sym ){
            	case SDLK_UP: mVelY += DOT_VEL; break;
            	case SDLK_DOWN: mVelY -= DOT_VEL; break;
            	case SDLK_LEFT: mVelX += DOT_VEL; break;
            	case SDLK_RIGHT: mVelX -= DOT_VEL; break;
        	}
		}
		mPosX += mVelX;
		if( ( mPosX < 0 ) || ( mPosX + 20 > 1280 ) ){

			mPosX -= mVelX;
		}
		mPosY += mVelY;

		if( ( mPosY < 0 ) || ( mPosY + 20 > 960 ) ){

			mPosY -= mVelY;
		}
		camera.x = ( mPosX + 20 / 2 ) - 640 / 2;
		camera.y = ( mPosY + 20 / 2 ) - 480 / 2;
				
		if( camera.x < 0 ){ 
			camera.x = 0;
		}
		if( camera.y < 0 ){
			camera.y = 0;
		}
		if( camera.x > 1280 - camera.w ){
			camera.x = 1280 - camera.w;
		}
		if( camera.y > 960 - camera.h ){
			camera.y = 960 - camera.h;
		}

		SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
		SDL_RenderClear( gRenderer );
		
		SDL_Rect renderQuad = { 0, 0, 640, 480 };
		//Renderizar fondo		
		SDL_RenderCopy( gRenderer, newTexture2, &camera, &renderQuad);
		renderQuad = { mPosX - camera.x, mPosY - camera.y, 20, 20 };
		//Renderizar cuadrado
		SDL_RenderCopy( gRenderer, newTexture, NULL, &renderQuad);

		SDL_RenderPresent( gRenderer );
		}
	}
}		
	
