#include "SDL.h"
#include "SDL_image.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
int mPosX=0; 
int mPosY=0;
SDL_Rect mCollider;
SDL_Rect wall;
SDL_Rect camera = { 0, 0, 640, 480 };
static const int DOT_WIDTH = 20;
static const int DOT_HEIGHT = 20;
static const int DOT_VEL = 10;
int mVelX=0; 
int mVelY=0;
SDL_Texture * mTexture=NULL;
SDL_Texture * newTexture2=NULL;
SDL_Texture * newTexture=NULL;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_EVERYTHING);

	SDL_Window * gWindow = SDL_CreateWindow( "Fondo en movimiento", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN );
	SDL_Renderer * gRenderer=SDL_CreateRenderer(gWindow,-1,SDL_RENDERER_PRESENTVSYNC);

	SDL_Surface* loadedSurface = IMG_Load( "cuadrado.png" );
	SDL_SetColorKey( loadedSurface, SDL_TRUE, SDL_MapRGB( loadedSurface->format, 0, 0xFF, 0xFF ) );
	SDL_Texture * newTexture = SDL_CreateTextureFromSurface( gRenderer, loadedSurface );
	loadedSurface = IMG_Load( "fd.png" );
	
	SDL_SetColorKey( loadedSurface, SDL_TRUE, SDL_MapRGB( loadedSurface->format, 0, 0xFF, 0xFF ) );
	SDL_Texture * newTexture2 = SDL_CreateTextureFromSurface( gRenderer, loadedSurface );
	bool quit = false;
	SDL_Event e;

	int scrollingOffset = 0;
	while( !quit ){
		while( SDL_PollEvent( &e ) != 0 ){
			if( e.type == SDL_QUIT ){
				quit = true;
			}else if( e.type == SDL_KEYDOWN ){
				if( e.key.keysym.sym == SDLK_ESCAPE ){
					quit = true;
				}
			}
			if( e.type == SDL_KEYDOWN && e.key.repeat == 0 ){

				switch( e.key.keysym.sym ){
					case SDLK_UP: mVelY -= DOT_VEL; break;
					case SDLK_DOWN: mVelY += DOT_VEL; break;
					case SDLK_LEFT: mVelX -= DOT_VEL; break;
					case SDLK_RIGHT: mVelX += DOT_VEL; break;
        		}
			}else if( e.type == SDL_KEYUP && e.key.repeat == 0 ){
		 		switch( e.key.keysym.sym ){
            		case SDLK_UP: mVelY += DOT_VEL; break;
            		case SDLK_DOWN: mVelY -= DOT_VEL; break;
            		case SDLK_LEFT: mVelX += DOT_VEL; break;
            		case SDLK_RIGHT: mVelX -= DOT_VEL; break;
        		}
    		}
		}
		mPosX += mVelX;
		if( ( mPosX < 0 ) || ( mPosX + 20 > 640 ) ){

			mPosX -= mVelX;
		}

		mPosY += mVelY;

		if( ( mPosY < 0 ) || ( mPosY + 20 > 480 ) ){

			mPosY -= mVelY;
		}
		--scrollingOffset;
		if( scrollingOffset < -640 ){
			scrollingOffset = 0;
		}
		SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
		SDL_RenderClear( gRenderer );
		//Renderiza primer fondo
		SDL_Rect renderQuad = { scrollingOffset, 0, 640, 480 };
		SDL_RenderCopy( gRenderer, newTexture2, NULL, &renderQuad);
		//Renderiza segundo fondo
		renderQuad = { scrollingOffset + 640, 0, 640, 480 };
		SDL_RenderCopy( gRenderer, newTexture2, NULL, &renderQuad);
		//Renderiza cuadrado
		renderQuad = { mPosX, mPosY, 20, 20 };
		SDL_RenderCopy( gRenderer, newTexture, NULL, &renderQuad);
		SDL_RenderPresent( gRenderer );
	}
}
		
	
