#include "SDL.h"
#include "SDL_ttf.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
SDL_Texture * mTexture=NULL;
SDL_Renderer *gRenderer = NULL;
SDL_Window * gWindow = NULL;
TTF_Font *gFont = NULL;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_EVERYTHING);
	TTF_Init();
	gWindow = SDL_CreateWindow( "Escribe lo que quieras", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN );
	gRenderer=SDL_CreateRenderer(gWindow,-1,SDL_RENDERER_PRESENTVSYNC);
	gFont = TTF_OpenFont( "tnfc.ttf", 28 );
	bool quit = false;

	SDL_Event e;
	SDL_Color textColor = { 0, 0, 0, 0xFF };
	std::string inputText = "Texto";
	SDL_Surface* textSurface = TTF_RenderText_Solid( gFont, inputText.c_str(), textColor );
	mTexture = SDL_CreateTextureFromSurface( gRenderer, textSurface );
	SDL_StartTextInput();

	while( !quit ){
		bool renderText = false;
		while( SDL_PollEvent( &e ) != 0 ){

			if( e.type == SDL_QUIT ){
				quit = true;
			}else if( e.type == SDL_KEYDOWN ){
				//Borra carácteres
				if( e.key.keysym.sym == SDLK_BACKSPACE && inputText.length() > 0 ){
					inputText.pop_back();
					renderText = true;
				//Copiar
				}else if( e.key.keysym.sym == SDLK_c && SDL_GetModState() & KMOD_CTRL ){
					SDL_SetClipboardText( inputText.c_str() );
				//Pegar				
				}else if( e.key.keysym.sym == SDLK_v && SDL_GetModState() & KMOD_CTRL ){
					inputText = SDL_GetClipboardText();
					renderText = true;
				}
			}else if( e.type == SDL_TEXTINPUT ){

				if( !( ( e.text.text[ 0 ] == 'c' || e.text.text[ 0 ] == 'C' ) && ( e.text.text[ 0 ] == 'v' || e.text.text[ 0 ] == 'V' ) && SDL_GetModState() & KMOD_CTRL ) ){

					inputText += e.text.text;
					renderText = true;
				}
			}
		}

		if( renderText ){
			if( inputText != "" ){

				SDL_Surface* textSurface = TTF_RenderText_Solid( gFont, inputText.c_str(), textColor );
				mTexture = SDL_CreateTextureFromSurface( gRenderer, textSurface );
				SDL_FreeSurface( textSurface );
				textSurface = TTF_RenderText_Solid( gFont, inputText.c_str(), textColor );
				mTexture = SDL_CreateTextureFromSurface( gRenderer, textSurface );
				SDL_FreeSurface( textSurface );
			}
		}

		SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
		SDL_RenderClear( gRenderer );

		SDL_Rect renderQuad = { ( SCREEN_WIDTH - 200 ) / 2, 0, 200, 200 };
		SDL_RenderCopy( gRenderer, mTexture, NULL, &renderQuad);
		
		SDL_RenderPresent( gRenderer );
	}
}

