#include "SDL.h"
#include "SDL_image.h"
#include "SDL_ttf.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
SDL_Texture* mTexture;
SDL_Texture* mTexture2;
SDL_Window * mWindow;
int mWidth=640;
int mHeight=480;
SDL_Renderer * gRenderer;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_EVERYTHING);
	TTF_Init();
	mWindow = SDL_CreateWindow( " ", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, SCREEN_WIDTH, SCREEN_HEIGHT, SDL_WINDOW_SHOWN | SDL_WINDOW_RESIZABLE );

	gRenderer=SDL_CreateRenderer(mWindow,-1,SDL_RENDERER_PRESENTVSYNC);
	SDL_Surface * tempsurface=IMG_Load("raton.png");
	mTexture = SDL_CreateTextureFromSurface( gRenderer, tempsurface ); 
	tempsurface=IMG_Load("teclado.png");
	mTexture2 = SDL_CreateTextureFromSurface( gRenderer, tempsurface ); 
	bool mMouseFocus,mKeyboardFocus,mMinimized;
	bool quit = false;
	SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
	SDL_RenderClear( gRenderer );
	SDL_Event e;

	while( !quit ){
		while( SDL_PollEvent( &e ) != 0 ){
			if( e.type == SDL_QUIT ){
				quit = true;
			}
			if( e.type == SDL_WINDOWEVENT ){
				bool updateCaption = false;
					switch( e.window.event ){
						//Get new dimensions and repaint on window size change
						case SDL_WINDOWEVENT_SIZE_CHANGED:
						mWidth = e.window.data1;
						mHeight = e.window.data2;
						SDL_RenderPresent( gRenderer );
						break;

						//Repaint on exposure
						case SDL_WINDOWEVENT_EXPOSED:
						SDL_RenderPresent( gRenderer );
						break;

						//Mouse entered window
						case SDL_WINDOWEVENT_ENTER:
						mMouseFocus = true;
						updateCaption = true;
						break;
			
						//Mouse left window
						case SDL_WINDOWEVENT_LEAVE:
						mMouseFocus = false;
						updateCaption = true;
						break;

						//Window has keyboard focus
						case SDL_WINDOWEVENT_FOCUS_GAINED:
						mKeyboardFocus = true;
						updateCaption = true;
						break;

						//Window lost keyboard focus
						case SDL_WINDOWEVENT_FOCUS_LOST:
						mKeyboardFocus = false;
						updateCaption = true;
						break;

						//Window minimized
						case SDL_WINDOWEVENT_MINIMIZED:
						mMinimized = true;
						break;

						//Window maxized
						case SDL_WINDOWEVENT_MAXIMIZED:
						mMinimized = false;
						break;
			
						//Window restored
						case SDL_WINDOWEVENT_RESTORED:
						mMinimized = false;
						break;
					}

					//Update window caption with new data
					if( updateCaption )
					{
						std::stringstream caption;
						caption << "Ratón dentro de la ventana:" << ( ( mMouseFocus ) ? "Sí" : "No" ) ;
						SDL_SetWindowTitle( mWindow, caption.str().c_str() );
					}
					if( mMouseFocus ){

						SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
						SDL_RenderClear( gRenderer );

					//Render text textures
						SDL_RenderCopy( gRenderer, mTexture, NULL, NULL);


					//Update screen
						SDL_RenderPresent( gRenderer );
					}else{
						SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
						SDL_RenderClear( gRenderer );

					//Render text textures
						SDL_RenderCopy( gRenderer, mTexture2, NULL, NULL);


					//Update screen
						SDL_RenderPresent( gRenderer );
					}
				}
			}
		}
	}
	

